VERSION 5.00
Begin VB.Form frmError 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Error"
   ClientHeight    =   4935
   ClientLeft      =   4440
   ClientTop       =   4215
   ClientWidth     =   7380
   Icon            =   "frmError.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4935
   ScaleWidth      =   7380
   Begin VB.PictureBox PictList 
      BackColor       =   &H00808080&
      Height          =   2490
      Left            =   0
      ScaleHeight     =   2430
      ScaleWidth      =   1095
      TabIndex        =   8
      Top             =   2400
      Width           =   1150
      Begin VB.CommandButton cmdInfo 
         Caption         =   "&Error Info."
         Height          =   375
         Index           =   4
         Left            =   0
         TabIndex        =   13
         Top             =   1440
         Width           =   1095
      End
      Begin VB.CommandButton cmdInfo 
         Caption         =   "D&river Info."
         Height          =   375
         Index           =   3
         Left            =   0
         TabIndex        =   12
         Top             =   1080
         Width           =   1095
      End
      Begin VB.CommandButton cmdInfo 
         Caption         =   "&Db Info."
         Height          =   375
         Index           =   2
         Left            =   0
         TabIndex        =   11
         Top             =   720
         Width           =   1095
      End
      Begin VB.CommandButton cmdInfo 
         Caption         =   "&App Info."
         Height          =   375
         Index           =   1
         Left            =   0
         TabIndex        =   10
         Top             =   360
         Width           =   1095
      End
      Begin VB.CommandButton cmdInfo 
         Caption         =   "&System Info."
         Height          =   375
         Index           =   0
         Left            =   0
         TabIndex        =   9
         Top             =   0
         Width           =   1095
      End
   End
   Begin VB.TextBox txtMore 
      Appearance      =   0  'Flat
      Height          =   2490
      Left            =   1200
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   7
      Top             =   2400
      Width           =   6135
   End
   Begin VB.CommandButton cmdDetails 
      Caption         =   "D&etails >>"
      Height          =   375
      Left            =   0
      TabIndex        =   6
      Top             =   1920
      Width           =   1095
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Continue"
      Height          =   375
      Left            =   3840
      TabIndex        =   5
      Top             =   1920
      Width           =   1095
   End
   Begin VB.TextBox txtErr 
      Appearance      =   0  'Flat
      Height          =   855
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      Top             =   960
      Width           =   7335
   End
   Begin VB.CommandButton cmdSendMail 
      Caption         =   "Send &Mail"
      Height          =   375
      Left            =   6240
      TabIndex        =   1
      Top             =   1920
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&Exit"
      Height          =   375
      Left            =   5040
      TabIndex        =   0
      Top             =   1920
      Width           =   1095
   End
   Begin VB.Image imgErr 
      Height          =   480
      Left            =   6720
      Picture         =   "frmError.frx":0442
      Top             =   240
      Width           =   480
   End
   Begin VB.Label lblException 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Exception ErrorHandler"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   240
      TabIndex        =   3
      Top             =   240
      Width           =   1950
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "An Exception Error Occured in PgAdmin2;"
      Height          =   195
      Left            =   360
      TabIndex        =   2
      Top             =   480
      Width           =   2955
   End
   Begin VB.Shape Shape1 
      BackStyle       =   1  'Opaque
      BorderStyle     =   0  'Transparent
      Height          =   855
      Left            =   0
      Top             =   0
      Width           =   7335
   End
End
Attribute VB_Name = "frmError"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' pgAdmin II - PostgreSQL Tools
' Copyright (C) 2001 - 2003, The pgAdmin Development Team
' This software is released under the pgAdmin Public Licence
'
' frmError.frm - Error form

' Note: No logging here

Option Explicit

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Const SW_SHOW = 5

Private Const MailSupport = "pgadmin-support@postgresql.org"


Dim objError As clsError

Public Sub Initialise(lError As Long, szError As String, szRoutine As String)
  Set objError = New clsError
  With objError
    .Description = szError
    .Number = lError
    .Routine = szRoutine
  End With

  Me.Caption = App.Title & " Error"
  
  'show description error
  txtErr.Text = objError.Description & objError.Troubleshooting
    
  Me.Height = Me.Height - txtMore.Height - 100
  
  'center form
  Me.Top = (Screen.Height - Me.Height) / 2
  Me.Left = (Screen.Width - Me.Width) / 2
End Sub

Private Sub cmdDetails_Click()
  If cmdDetails.Caption = "D&etails >>" Then
    Me.Height = Me.Height + txtMore.Height + 100
    cmdDetails.Caption = "<< D&etails"
    
    'show detail error
    cmdInfo_Click (4)
  Else
    Me.Height = Me.Height - txtMore.Height - 100
    cmdDetails.Caption = "D&etails >>"
  End If
End Sub
Private Sub cmdInfo_Click(Index As Integer)
Dim szTemp As String

  If Index = 0 Then
    txtMore.Text = objError.GetInfo(TIE_SYSTEM)
  ElseIf Index = 1 Then
    txtMore.Text = objError.GetInfo(TIE_APPLICATION)
  ElseIf Index = 2 Then
    txtMore.Text = objError.GetInfo(TIE_DATABASE)
  ElseIf Index = 3 Then
    txtMore.Text = objError.GetInfo(TIE_DRIVER_ODBC)
  ElseIf Index = 4 Then
    txtMore.Text = objError.GetInfo(TIE_ERROR)
  End If
End Sub

Private Sub cmdOK_Click()
  End
End Sub

Private Sub cmdSendMail_Click()
Dim szMail As String
Dim szTemp As String
Dim szSep As String

  szSep = String(60, "=")

  szTemp = objError.GetInfo(TIE_SYSTEM) & szSep & vbCrLf
  szTemp = szTemp & objError.GetInfo(TIE_APPLICATION) & szSep & vbCrLf
  szTemp = szTemp & objError.GetInfo(TIE_DATABASE) & szSep & vbCrLf
  szTemp = szTemp & objError.GetInfo(TIE_DRIVER_ODBC) & szSep & vbCrLf
  szTemp = szTemp & objError.GetInfo(TIE_ERROR) & String(60, "*") & vbCrLf
  szTemp = szTemp & "Insert your comment:" & vbCrLf

  szMail = "mailto:" & MailSupport & "?subject=Error Message&body=" & szTemp
  szMail = Replace(szMail, " ", "%20")
  szMail = Replace(szMail, Chr(10), "%0" & Hex(10))
  szMail = Replace(szMail, Chr(13), "%0" & Hex(13))
  szMail = Replace(szMail, Chr(32), "%0" & Hex(32))
  szMail = Replace(szMail, Chr(59), "%0" & Hex(59))
  
  'open shell
  ShellExecute hWnd, "open", szMail, vbNullString, vbNullString, SW_SHOW
End Sub

Private Sub Command1_Click()
  Unload Me
End Sub

